#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire200one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one2004xi    


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                  
# -------------------------------------------------------------------------------------------------
# 200
# -------------------------------------------------------------------------------------------------                                          
shot2one2004xi = {
                  1:'0x0y199z',
                  2:'0x132y149z',
                  3:'0x180y87z',
                  4:'0x23y198z',
                  5:'0x25y198z',
                  6:'0x2y199z',
                  7:'0x4y199z',
                  8:'0x6y199z',
                  9:'0x8y199z',
                  10:'101x145y92z',
                  11:'102x110y131z',
                  12:'102x77y152z',
                  13:'105x130y109z',
                  14:'105x71y154z',
                  15:'107x103y133z',
                  16:'108x139y94z',
                  17:'110x123y111z',
                  18:'111x97y134z',
                  19:'114x132y96z',
                  20:'115x90y136z',
                  21:'116x116y113z',
                  22:'118x83y137z',
                  23:'11x165y111z',
                  24:'11x9y299z',
                  25:'120x125y97z',
                  26:'121x109y114z',
                  27:'126x102y116z',
                  28:'126x118y99z',
                  29:'130x95y117z',
                  30:'131x111y101z',
                  31:'136x103y102z',
                  32:'13x128y152z',
                  33:'13x151y130z',
                  34:'15x185y74z',
                  35:'160x0y119z',
                  36:'18x177y90z',
                  37:'1x0y199z',
                  38:'1x1y199z',
                  39:'1x21y198z',
                  40:'20x126y153z',
                  41:'20x148y131z',
                  42:'20x163y112z',
                  43:'25x183y76z',
                  44:'26x123y155z',
                  45:'27x175y92z',
                  46:'28x146y133z',
                  47:'28x161y114z',
                  48:'2x167y109z',
                  49:'2x19y199z',
                  50:'2x3y199z',
                  51:'2x5y199z',
                  52:'32x120y156z',
                  53:'34x180y78z',
                  54:'35x143y134z',
                  55:'36x158y116z',
                  56:'36x172y94z',
                  57:'38x117y157z',
                  58:'3x0y199z',
                  59:'3x15y199z',
                  60:'3x17y199z',
                  61:'3x7y199z',
                  62:'3x9y199z',
                  63:'42x139y136z',
                  64:'43x113y158z',
                  65:'43x178y79z',
                  66:'44x155y117z',
                  67:'45x169y96z',
                  68:'48x109y159z',
                  69:'49x136y137z',
                  70:'4x11y199z',
                  71:'4x13y199z',
                  72:'52x151y119z',
                  73:'52x174y81z',
                  74:'53x105y161z',
                  75:'53x166y97z',
                  76:'56x132y139z',
                  77:'58x101y162z',
                  78:'59x147y120z',
                  79:'5x0y199z',
                  80:'5x152y128z',
                  81:'5x186y72z',
                  82:'61x162y99z',
                  83:'61x170y83z',
                  84:'62x127y140z',
                  85:'62x96y163z',
                  86:'66x143y122z',
                  87:'66x91y164z',
                  88:'68x123y142z',
                  89:'69x157y101z',
                  90:'6x130y151z',
                  91:'6x4y199z',
                  92:'70x166y85z',
                  93:'70x86y165z',
                  94:'73x118y143z',
                  95:'73x138y124z',
                  96:'73x81y166z',
                  97:'76x76y167z',
                  98:'77x152y102z',
                  99:'78x162y87z',
                  100:'79x112y144z',
                  101:'79x71y169z',
                  102:'80x133y125z',
                  103:'81x66y170z',
                  104:'83x107y146z',
                  105:'83x60y171z',
                  106:'84x147y104z',
                  107:'86x128y127z',
                  108:'86x156y88z',
                  109:'88x101y147z',
                  110:'92x122y128z',
                  111:'92x142y106z',
                  112:'92x95y149z',
                  113:'93x151y90z',
                  114:'96x89y150z',
                  115:'97x116y130z',
                  116:'98x136y108z',
                  117:'99x83y151z',
                  118:'9x178y88z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire200one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire200one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE200ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE2004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200ONE4XI - SUCCEEDED TO PUT SHOT2ONE2004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE2004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200ONE4XI *** FAILED TO PUT SHOT2ONE2004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one2004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one2004xi</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------

        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one2004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE200ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
